#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = double;
#define all(x) (x).begin(), (x).end()
#define int long long


struct point {
    long double x;
    long double y;

    point(long double _x = 0, long double _y = 0) {
        x = _x;
        y = _y;
    }

    point operator+(point p2) {
        return point(x + p2.x, y + p2.y);
    }

    point operator-(point p2) {
        return point(x - p2.x, y - p2.y);
    }

    point operator*(point p2) {
        //using complex number multiplying
        long double resx, resy;
        resx = x * p2.x - y * p2.y;
        resy = y * p2.x + x * p2.y;
        return point(resx, resy);
    }

    point rotate(point p2) {
        //using complex number multiplying
        long double resx, resy;
        resx = x * p2.x - y * p2.y;
        resy = y * p2.x + x * p2.y;
        point px(resx, resy);
        if (x == 0 && y == 0)return {0, 0};
        return point(resx / px.lenth() * lenth(), resy / px.lenth() * lenth());
    }

    point rotation(long double angle) {
        //rotates vector from O to Point at angle
        //using complex numbers theory to do that
        //res=p*z; where z=cos(alpha)+i*sin(alpha); p-coords of point as complex naumber; p=x+y*i;
        double zx = cos(angle);
        double zy = sin(angle);
        point z(zx, zy);
        return ((*this) * z);
    }

    long double angle_between_vectors(point p2) {
        return atan2(x * p2.y - p2.x * y, x * p2.x + y * p2.y);
    }

    long double lenth() {
        return sqrt(x * x + y * y);
    }

    long double cross(point p2) {
        return x * p2.y - y * p2.x;
    }

    long double scal_multyply(point p2) {
        return x * p2.x + y * p2.y;
    }
};

struct line {
    long double a, b, c;

    line(long double _a = 0, long double _b = 0, long double _c = 0) {
        a = _a;
        b = _b;
        c = _c;
    }

    point random_point() {
        long double x, y;
        if (b != 0) {
            x = 0;
            y = -c / b;
        } else {
            x = -c / a;
            y = 0;
        }
        return point(x, y);
    }

    point normal_vector() {
        point p1(0, 0), p2(0, 0);
        if (b != 0) {
            p1.x = 0;
            p1.y = -c / b;
            p2.x = 1;
            p2.y = -(c + a) / b;
        } else {
            p1.x = -c / a;
            p1.y = 0;
            p2.x = -c / a;
            p2.y = 1;
        }
        point p = p2 - p1;
        point normal(0, 0);
        normal = p.rotation(atan2(1, 0));
        return normal;
    }
};

line find_line(point p, point p2) {
    long double a, b, c;
    a = p.y - p2.y;
    b = p2.x - p.x;
    c = -a * p.x - b * p.y;
    return line(a, b, c);
}

long double distance_from_point_to_line(point p, point p1, point p2) {
    return (long double) ((p - p1).cross(p2 - p1) / ((p2 - p1).lenth()));
}

long double distance_from_point_to_ray(point p, point p1, point p2) {
    if (((p2 - p1).scal_multyply(p - p1)) >= 0) {
        return abs(distance_from_point_to_line(p, p1, p2));
    } else {
        return (p - p1).lenth();
    }
}

long double distance_from_point_to_segment(point p, point p1, point p2) {
    if (((p2 - p1).scal_multyply(p - p1)) >= 0 && ((p1 - p2).scal_multyply(p - p2)) >= 0) {
        return abs(distance_from_point_to_line(p, p1, p2));
    } else {
        return min((p - p1).lenth(), (p - p2).lenth());
    }
}

long double distance_from_segment_to_segment(point p, point p1, point p2, point p3) {
    return min(min(min(distance_from_point_to_segment(p, p2, p3), distance_from_point_to_segment(p1, p2, p3)),
                   distance_from_point_to_segment(p2, p, p1)), distance_from_point_to_segment(p3, p, p1));
}

point a[12];
point b[12];
bool used[12];

ld ans_for_b(int n, int ind, int d, int hh, int hhh) {
    if (d == n)return (ld) 0;
    ld res = 23241324413241231;
    if(ind==hh && !used[hhh]) {
        used[hhh] = true;
        ld nw = abs(b[ind].x - b[hhh].x) + abs(b[ind].y - b[hhh].y) + ans_for_b(n, hhh, d + 1, hh, hhh);

        used[hhh] = false;
        return nw;
    }
    if(ind==hhh && !used[hh]) {
        used[hh] = true;
        ld nw = abs(b[ind].x - b[hh].x) + abs(b[ind].y - b[hh].y) + ans_for_b(n, hh, d + 1, hh, hhh);

        used[hh] = false;
        return nw;
    }
    for (int i = 0; i < n; i++) {
        if(d==1 && i>n/2)break; 
        if (!used[i]) {
            used[i] = true;
            ld nw = abs(b[ind].x - b[i].x) + abs(b[ind].y - b[i].y) + ans_for_b(n, i, d + 1, hh, hhh);
            if (res > nw) {
                res = nw;
            }
            used[i] = false;
        }
    }
    return res;
}

void solve() {
    int n, m, k, i;
    ld res = 21312124313;
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    for (i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            point r = {-(a[j] - a[i]).y, -(a[j] - a[i]).x};
            for (k = 0; k < n; k++) {
                b[k] = a[k].rotate(r);
            }
            for (k = 0; k < n; k++) {
                used[k] = 1;
                res = min(res, ans_for_b(n, k, 1, i, j));
                used[k] = 0;
            }
        }
    }
    cout << res;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int qwe = 1;
    // cin >> qwe;
    cout.precision(12);
    while (qwe--) {
        solve();
    }
    return 0;
}
