#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = double;
#define all(x) (x).begin(), (x).end()
#define int long long


struct point {
    double x;
    double y;

    point(double _x = 0, double _y = 0) {
        x = _x;
        y = _y;
    }

    point operator+(point p2) {
        return point(x + p2.x, y + p2.y);
    }

    point operator-(point p2) {
        return point(x - p2.x, y - p2.y);
    }

    point operator*(point p2) {
        //using complex number multiplying
        double resx, resy;
        resx = x * p2.x - y * p2.y;
        resy = y * p2.x + x * p2.y;
        return point(resx, resy);
    }

    point rotate(point p2) {
        //using complex number multiplying
        double resx, resy;
        resx = x * p2.x - y * p2.y;
        resy = y * p2.x + x * p2.y;
        point px(resx, resy);
        if (x == 0 && y == 0)return {0, 0};
        return point(resx / px.lenth() * lenth(), resy / px.lenth() * lenth());
    }

    point rotation(double angle) {
        //rotates vector from O to Point at angle
        //using complex numbers theory to do that
        //res=p*z; where z=cos(alpha)+i*sin(alpha); p-coords of point as complex naumber; p=x+y*i;
        double zx = cos(angle);
        double zy = sin(angle);
        point z(zx, zy);
        return ((*this) * z);
    }

    double angle_between_vectors(point p2) {
        return atan2(x * p2.y - p2.x * y, x * p2.x + y * p2.y);
    }

    double lenth() {
        return sqrt(x * x + y * y);
    }

    double cross(point p2) {
        return x * p2.y - y * p2.x;
    }

    double scal_multyply(point p2) {
        return x * p2.x + y * p2.y;
    }
};

struct line {
    double a, b, c;

    line(double _a = 0, double _b = 0, double _c = 0) {
        a = _a;
        b = _b;
        c = _c;
    }

    point random_point() {
        double x, y;
        if (b != 0) {
            x = 0;
            y = -c / b;
        } else {
            x = -c / a;
            y = 0;
        }
        return point(x, y);
    }

    point normal_vector() {
        point p1(0, 0), p2(0, 0);
        if (b != 0) {
            p1.x = 0;
            p1.y = -c / b;
            p2.x = 1;
            p2.y = -(c + a) / b;
        } else {
            p1.x = -c / a;
            p1.y = 0;
            p2.x = -c / a;
            p2.y = 1;
        }
        point p = p2 - p1;
        point normal(0, 0);
        normal = p.rotation(atan2(1, 0));
        return normal;
    }
};

line find_line(point p, point p2) {
    double a, b, c;
    a = p.y - p2.y;
    b = p2.x - p.x;
    c = -a * p.x - b * p.y;
    return line(a, b, c);
}

double distance_from_point_to_line(point p, point p1, point p2) {
    return (double) ((p - p1).cross(p2 - p1) / ((p2 - p1).lenth()));
}

double distance_from_point_to_ray(point p, point p1, point p2) {
    if (((p2 - p1).scal_multyply(p - p1)) >= 0) {
        return abs(distance_from_point_to_line(p, p1, p2));
    } else {
        return (p - p1).lenth();
    }
}

double distance_from_point_to_segment(point p, point p1, point p2) {
    if (((p2 - p1).scal_multyply(p - p1)) >= 0 && ((p1 - p2).scal_multyply(p - p2)) >= 0) {
        return abs(distance_from_point_to_line(p, p1, p2));
    } else {
        return min((p - p1).lenth(), (p - p2).lenth());
    }
}

double distance_from_segment_to_segment(point p, point p1, point p2, point p3) {
    return min(min(min(distance_from_point_to_segment(p, p2, p3), distance_from_point_to_segment(p1, p2, p3)),
                   distance_from_point_to_segment(p2, p, p1)), distance_from_point_to_segment(p3, p, p1));
}

point a[12];
point b[12];
vector<int>c;

void solve() {
    int n, m, k, i;
    ld res = 21312124313;
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> a[i].x >> a[i].y;
    }
    c.resize(n);
    for(i=0; i<n; i++)c[i]=i;
    for (i = 0; i < n-1; i++) {
        point r = {-(a[i+1] - a[i]).y, -(a[i+1] - a[i]).x};
        for (k = 0; k < n; k++) {
            b[k] = a[k].rotate(r);
        }
        ld ans=0;
        for (i = 0; i < n-1; i++) {
            ans+=abs(b[c[i]].x-b[c[i+1]].x)+abs(b[c[i]].y-b[c[i+1]].y);
        }
        res=min(res, ans);
    }
    while(next_permutation(c.begin(),c.end())) {
        for (i = 0; i < n-1; i++) {
            point r = {-(a[i+1] - a[i]).y, -(a[i+1] - a[i]).x};
            for (k = 0; k < n; k++) {
                b[k] = a[k].rotate(r);
            }
            ld ans=0;
            for (i = 0; i < n-1; i++) {
                ans+=abs(b[c[i]].x-b[c[i+1]].x)+abs(b[c[i]].y-b[c[i+1]].y);
            }
            res=min(res, ans);
        }
    }
    cout << res;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int qwe = 1;
    // cin >> qwe;
    cout.precision(12);
    while (qwe--) {
        solve();
    }
    return 0;
}
